package org.apache.myfaces.tobago.context;

/*
 * Copyright 2002-2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import javax.faces.component.UIViewRoot;
import javax.faces.render.Renderer;
import java.util.Locale;

public interface ResourceManager {

  String getJsp(UIViewRoot viewRoot, String name);

  String getProperty(UIViewRoot viewRoot, String bundle, String propertyKey);

  String getProperty(
      ClientProperties clientProperties, Locale locale,
      String bundle, String propertyKey);

  Renderer getRenderer(UIViewRoot viewRoot, String name);

  String[] getScripts(UIViewRoot viewRoot, String name);

  String[] getStyles(UIViewRoot viewRoot, String name);

  String getThemeProperty(UIViewRoot viewRoot,
      String bundle, String propertyKey);

  String getImage(UIViewRoot viewRoot, String name);

  String getImage(UIViewRoot viewRoot, String name, boolean ignoreMissing);
}
